#include <stdio.h>
#include <allegro.h>

#include "mapedit.h"
#include "keyboard.h"

int KBD_Mapedit(void)
{
   if(key[KEY_UP])                  //*!* User pressed the <UP arrow>
   {
      if(PL_player.y > 10)
      {
         PL_player.y -=1;
         if(key_shifts & KB_SHIFT_FLAG)
         {
            display_map_fast();
         } else
         {
            display_map();
         }
      }
      UpdateStats();
   } else if(key[KEY_DOWN])         //*!* User pressed the <DOWN arrow>
   {
      if(PL_player.y < 490)
      {
         PL_player.y += 1;
         if(key_shifts & KB_SHIFT_FLAG)
         {
            display_map_fast();
         } else
         {
            display_map();
         }
      }
      UpdateStats();
   } else if(key[KEY_LEFT])         //*!* User pressed the <DOWN arrow>
   {
      if(key_shifts & KB_CTRL_FLAG)
      {
         if(key_shifts & KB_ALT_FLAG)
         {
            if(PL_player.curtile>0)
            {
               PL_player.curtile--;
               display_map_fast();
            }
         } else if(PL_player.curtile>0)
         {
            PL_player.curtile--;
            display_map();
         }
      } else if(PL_player.x > 10)
      {
         PL_player.x -= 1;
         if(key_shifts & KB_SHIFT_FLAG)
         {
            display_map_fast();
         } else
         {
            display_map();
         }
      }
      UpdateStats();
   } else if(key[KEY_RIGHT])        //*!* User pressed the <RIGHT arrow>
   {
      if(key_shifts & KB_CTRL_FLAG)
      {
         if(key_shifts & KB_ALT_FLAG)
         {
            if(PL_player.curtile<240)
            {
               PL_player.curtile++;
               display_map_fast();
            }
         } else if(PL_player.curtile<240)
         {
            PL_player.curtile++;
            display_map();
         }
      } else if(KeyWay < 490)
      {
         PL_player.x += 1;
         if(key_shifts & KB_SHIFT_FLAG)
         {
            display_map_fast();
         } else
         {
            display_map();
         }
      }
      UpdateStats();
   } else if(key[KEY_E])
   {
      switch(Map[PL_player.x+8][PL_player.y+4].enemy)
      {
         case 0:
            Map[PL_player.x+8][PL_player.y+4].enemy=1;
            break;
         case 1:
            Map[PL_player.x+8][PL_player.y+4].enemy=0;
            break;
      }            
      display_map();
   } else if(key[KEY_W])
   {
      switch(Map[PL_player.x+8][PL_player.y+4].walk)
      {
         case 0:
            Map[PL_player.x+8][PL_player.y+4].walk=1;
            break;
         case 1:
            Map[PL_player.x+8][PL_player.y+4].walk=0;
            break;
      }            
      display_map();
      UpdateStats();
   } else if(key[KEY_F])
   {
      Map[PL_player.x+8][PL_player.y+4].tile = PL_player.curtile;
         display_map();
      UpdateStats();
   } else if(key[KEY_G])
   {
      Map[PL_player.x+8][PL_player.y+4].layer2 = PL_player.curtile;
         display_map();
      UpdateStats();
   } else if(key[KEY_D])
   {
      if(Map[PL_player.x][PL_player.y].walk = 0)
      {
         Map[PL_player.x][PL_player.y].walk = 1;
      } else
      {
         Map[PL_player.x][PL_player.y].walk = 0;
      }
         display_map();
//         do_editor();
      UpdateStats();
   } else if(key[KEY_S])
   {
      if(key_shifts & KB_CTRL_FLAG)
      {
         save_map();
         display_map();
      }
   } else if(key[KEY_L])
   {
      if(key_shifts & KB_CTRL_FLAG)
      {
         load_map();
         display_map();
      }
      UpdateStats();
   } else if(key[KEY_ESC])          // *!* User pressed <ESC>
   {
      do_shutdown();
      exit(1);
      return(0);                 //  *-* game exits here
   }
   return(0);
}

