#include <stdio.h>
#include <allegro.h>

#include "prjxmain.h"
#include "central.h"

int MAP_NewGame(void)
{
   PALLETE pallete1;

   TGA_MapPlayerUP=load_bitmap("GRAFIX\\GUY_U.TGA",pallete1);
   TGA_MapPlayerDOWN=load_bitmap("GRAFIX\\GUY_D.TGA",pallete1);
   TGA_MapPlayerLEFT=load_bitmap("GRAFIX\\GUY_L.TGA",pallete1);
   TGA_MapPlayerRIGHT=load_bitmap("GRAFIX\\GUY_R.TGA",pallete1);
   if(MidiVol)
      playmidi("AUDIO\\NIGHTLND.MID"); // Start the music
   srand(time());
   MH_MessageNeeded=0;
   PL_player.x = 30;
   PL_player.y = 26;
   PL_player.hp = 85;
   PL_player.mp = 50;
   PL_player.ammo = 100;
   PL_player.level = 0;
   PL_player.exp = 0;
   PL_player.direction=0;

   return(0);
}


int do_logo(void)
{
   GAME_STAT=LOGO;
   delay(2000);
   showpict("GRAFIX\\21STMRWN.TGA",0,0,0,0,320,200);
   playwav("AUDIO\\LIGHTNG.WAV");
   delay(5000);
   fade_out(1);
   delay(2000);
   return(0);
}

int ClearTileChecked(void)
{
   int temp1,temp2;

   for(temp1=0;temp1<500;temp1++)
      for(temp2=0;temp2<500;temp2++)
      {
         TileChecked[temp1][temp2]=0;
      }
   return(0);
}

int StartNewGame(void)
{
   KeyWay=0;
   fade_out(2);
   MAP_NewGame();
   MAP_LoadTiles();
   MAP_LoadMap("DAT\\MAP.DAT");
   MAP_LoadEnemies();
   MAP_LoadBG();
   MAP_DisplayBG();
   MAP_DisplayMap();
   MAP_ShowPlayer(0);
   GAME_STAT=MAINMAP;
   return(0);
}

int PL_AddEXP(int expTmp)
{
   if(PL_player.level < 99) //if he's level 98 or below (he'll still jump to 99, but when he gets there, no exp will be added)
   {
      PL_player.exp += expTmp;   //add th exp to the player
      if(PL_player.exp>=1500)  // if the exp points = 1500
      {
         PL_player.level++;  // up the level
         PL_player.exp=0;  //return the exp to 0
         PL_player.hp+=30;  //Up his hit points for gaining a level
         PL_player.mp+=30;  //Up his hit points for gaining a level
         PL_player.ammo+=30;  //Up his hit points for gaining a level
      }
   }
   return(0);
}

int PL_AddHP(int hpTmp)
{
   if((PL_player.hp+hpTmp) <= ((27*PL_player.level)+85)) //If when you add the HP, it's less than or equal to the level max, it's ok to add it
   {
      PL_player.hp += hpTmp;
   } else if((PL_player.hp+hpTmp) > ((27*PL_player.level)+85))  //If when you add the HP, it's greater than the level max, put it at the level max
   {
      PL_player.hp = (27*PL_player.level)+85;
   }
   return(0);
}

int PL_AddMP(int mpTmp)
{
   if((PL_player.mp+mpTmp) <= ((16*PL_player.level)+50)) //If when you add the mp, it's less than or equal to the level max, it's ok to add it
   {
      PL_player.mp += mpTmp;
   } else if((PL_player.mp+mpTmp) > ((16*PL_player.level)+50))  //If when you add the mp, it's greater than the level max, put it at the level max
   {
      PL_player.mp = (16*PL_player.level)+50;
   }
   return(0); 
}

int PL_AddAMMO(int ammoTmp)
{
   if((PL_player.ammo+ammoTmp) <= ((47*PL_player.level)+100)) //If when you add the ammo, it's less than or equal to the level max, it's ok to add it
   {
      PL_player.ammo += ammoTmp;
   } else if((PL_player.ammo+ammoTmp) > ((47*PL_player.level)+100))  //If when you add the ammo, it's greater than the level max, put it at the level max
   {
      PL_player.ammo = (47*PL_player.level)+100;
   }
   return(0); 
}

